import sys

import ez_setup
ez_setup.use_setuptools()

from setuptools import setup, Extension

install_requires = ["BeautifulSoup"]
if "develop" in sys.argv:
	install_requires = []

setup(name="smallwp",
	version="0.5",
	description="Small wikipedia server",
	url="http://www.tfiu.de/smallwp",
	license="GPL",
	author="Markus Demleitner",
	author_email="msdemlei@users.sf.net",
	packages=["smallwp"],
	py_modules=["ez_setup"],
	package_data = {
		'smallwp': ["resources/*"],
	},
	ext_modules=[
		Extension("Looker", ["Lookermodule.c"])
	],	
	install_requires=install_requires,
	entry_points={
		'console_scripts': [
			'splitWp = smallwp.splitstuff:main',
			'wpGui = smallwp.wpGui:main',
			'wpTui = smallwp.wpserver:main',
		]
	},)
