import wpserver, wtparse
import random
import traceback
import os

from smallwp import wpdata
from smallwp import wpprefs

def makeRandomName(length=8):
	return "".join([chr(random.randint(ord('a'), ord('z')))
		for i in range(length)])

def saveToUniqName(text, basedir="badfiles"):
	# Aw, leave me alone with your race conditions...
	while 1:
		targetName = os.path.join(basedir, makeRandomName())
		if not os.path.exists(targetName):
			break
	f = open(targetName, "w")
	f.write(text)
	f.close()
	
if __name__=="__main__":
	wpData = wpdata.makeData()
	for pagename, data in wpData.iterContents():
		print pagename.encode("iso-8859-1", "xmlcharrefreplace")
		try:
			data = data.encode("utf-8")
			wtparse.parse(data)
		except wpprefs.PageNotFound:
			print pagename.encode("iso-8859-1", "xmlcharrefreplace"), "not found"
		except ValueError:
			traceback.print_exc()
			saveToUniqName(data)
