import cPickle

def makeSections(pagesFileName, targetLength):

	def buildHierarchy(sectionsList, targetLength):
		if len(sectionsList)<targetLength:
			return sectionsList
		thisLevelSections = []
		startIndex = 0
		while 1:
			endIndex = startIndex+targetLength
			if endIndex>len(sectionsList)-10:
				thisLevelSections.append((sectionsList[startIndex][0],
					sectionsList[-1][1], tuple(sectionsList[startIndex:])))
				break
			else:
				thisLevelSections.append((sectionsList[startIndex][0],
					sectionsList[endIndex-1][1], 
					tuple(sectionsList[startIndex:endIndex])))
			startIndex += targetLength
		return buildHierarchy(thisLevelSections, targetLength)

	def getKey(indexLine):
		return indexLine.decode("utf-8").split("\t")[0]

	sections = []
	f = open(pagesFileName)
	startKey, startPos = getKey(f.readline()), 0
	curNumItems = 1
	while 1:
		pos = f.tell()
		curLine = f.readline()
		if not curLine:
			sections.append(((startKey, startPos), 
				(getKey(curLine), pos), ()))
			break
		if curNumItems>=targetLength:
			sections.append(((startKey, startPos), 
				(getKey(lastLine), pos), ()))
			startKey, startPos = getKey(curLine), pos
			curNumItems = 0
		lastLine = curLine
		curNumItems += 1
	return buildHierarchy(sections, targetLength)


if __name__=="__main__":
	cPickle.dump(makeSections("wppages/pages.index", 50),
		open("wppages/sections.pickle", "w"))
